org.apache.tomcat.dbcp.pool

## Interface KeyedObjectPool<K,V>

- Type Parameters:
    `K` - the type of keys in this pool
    `V` - the type of objects held in this pool
  All Known Implementing Classes:
    BaseKeyedObjectPool, GenericKeyedObjectPool, StackKeyedObjectPool

      public interface KeyedObjectPool<K,V>

  A "keyed" pooling interface.

  A keyed pool pools instances of multiple types. Each type may be accessed using an arbitrary key.

  Example of use:

       Object obj = null;
       Object key = "Key";

       try {
           obj = pool.borrowObject(key);
           //...use the object...
       } catch(Exception e) {
           // invalidate the object
           pool.invalidateObject(key, obj);
           // do not return the object to the pool twice
           obj = null;
       } finally {
           // make sure the object is returned to the pool
           if(null != obj) {
               pool.returnObject(key, obj);
           }
       }

  `KeyedObjectPool` implementations may choose to store at most one instance per key value, or may choose to maintain a pool of instances for each key (essentially creating a `Map` of `pools`).

  See `BaseKeyedObjectPool` for a simple base implementation.

  Since:
    Pool 1.0
  Author:
    Rodney Waldhoff, Sandy McArthur
  See Also:
    `KeyedPoolableObjectFactory`, `KeyedObjectPoolFactory`, `ObjectPool`, `BaseKeyedObjectPool`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addObject(K key)` Create an object using the `factory` or other implementation dependent mechanism, passivate it, and then place it in the idle object pool.
    `V` | `borrowObject(K key)` Obtains an instance from this pool for the specified `key`.
    `void` | `clear()` Clears the pool, removing all pooled instances (optional operation).
    `void` | `clear(K key)` Clears the specified pool, removing all pooled instances corresponding to the given `key` (optional operation).
    `void` | `close()` Close this pool, and free any resources associated with it.
    `int` | `getNumActive()` Returns the total number of instances current borrowed from this pool but not yet returned (optional operation).
    `int` | `getNumActive(K key)` Returns the number of instances currently borrowed from but not yet returned to the pool corresponding to the given `key` (optional operation).
    `int` | `getNumIdle()` Returns the total number of instances currently idle in this pool (optional operation).
    `int` | `getNumIdle(K key)` Returns the number of instances corresponding to the given `key` currently idle in this pool (optional operation).
    `void` | `invalidateObject(K key, V obj)` Invalidates an object from the pool.
    `void` | `returnObject(K key, V obj)` Return an instance to the pool.
    `void` | `setFactory(KeyedPoolableObjectFactory<K,V> factory)` Deprecated. to be removed in pool 2.0

- - ### Method Detail

    - #### borrowObject

          V borrowObject(K key)
                         throws java.lang.Exception,
                                java.util.NoSuchElementException,
                                java.lang.IllegalStateException

      Obtains an instance from this pool for the specified `key`.

      Instances returned from this method will have been either newly created with `makeObject` or will be a previously idle object and have been activated with `activateObject` and then validated with `validateObject`.

      By contract, clients must return the borrowed object using `returnObject`, `invalidateObject`, or a related method as defined in an implementation or sub-interface, using a `key` that is `equivalent` to the one used to borrow the instance in the first place.

      The behaviour of this method when the pool has been exhausted is not strictly specified (although it may be specified by implementations). Older versions of this method would return `null` to indicate exhaustion, newer versions are encouraged to throw a `NoSuchElementException`.

      Parameters:
        `key` - the key used to obtain the object
      Returns:
        an instance from this pool.
      Throws:
        `java.lang.IllegalStateException` - after `close` has been called on this pool
        `java.lang.Exception` - when `makeObject` throws an exception
        `java.util.NoSuchElementException` - when the pool is exhausted and cannot or will not return another instance

    - #### returnObject

          void returnObject(K key,
                          V obj)
                            throws java.lang.Exception

      Return an instance to the pool. By contract, `obj` must have been obtained using `borrowObject` or a related method as defined in an implementation or sub-interface using a `key` that is equivalent to the one used to borrow the instance in the first place.
      Parameters:
        `key` - the key used to obtain the object
        `obj` - a `borrowed` instance to be returned.
      Throws:
        `java.lang.Exception`

    - #### invalidateObject

          void invalidateObject(K key,
                              V obj)
                                throws java.lang.Exception

      Invalidates an object from the pool.

      By contract, `obj` must have been obtained using `borrowObject` or a related method as defined in an implementation or sub-interface using a `key` that is equivalent to the one used to borrow the `Object` in the first place.

      This method should be used when an object that has been borrowed is determined (due to an exception or other problem) to be invalid.

      Parameters:
        `key` - the key used to obtain the object
        `obj` - a `borrowed` instance to be returned.
      Throws:
        `java.lang.Exception`

    - #### addObject

          void addObject(K key)
                         throws java.lang.Exception,
                                java.lang.IllegalStateException,
                                java.lang.UnsupportedOperationException

      Create an object using the `factory` or other implementation dependent mechanism, passivate it, and then place it in the idle object pool. `addObject` is useful for "pre-loading" a pool with idle objects (Optional operation).
      Parameters:
        `key` - the key a new instance should be added to
      Throws:
        `java.lang.Exception` - when `KeyedPoolableObjectFactory.makeObject(K)` fails.
        `java.lang.IllegalStateException` - after `close()` has been called on this pool.
        `java.lang.UnsupportedOperationException` - when this pool cannot add new idle objects.

    - #### getNumIdle

          int getNumIdle(K key)
                         throws java.lang.UnsupportedOperationException

      Returns the number of instances corresponding to the given `key` currently idle in this pool (optional operation). Returns a negative value if this information is not available.
      Parameters:
        `key` - the key to query
      Returns:
        the number of instances corresponding to the given `key` currently idle in this pool or a negative value if unsupported
      Throws:
        `java.lang.UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

    - #### getNumActive

          int getNumActive(K key)
                           throws java.lang.UnsupportedOperationException

      Returns the number of instances currently borrowed from but not yet returned to the pool corresponding to the given `key` (optional operation). Returns a negative value if this information is not available.
      Parameters:
        `key` - the key to query
      Returns:
        the number of instances corresponding to the given `key` currently borrowed in this pool or a negative value if unsupported
      Throws:
        `java.lang.UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

    - #### getNumIdle

          int getNumIdle()
                         throws java.lang.UnsupportedOperationException

      Returns the total number of instances currently idle in this pool (optional operation). Returns a negative value if this information is not available.
      Returns:
        the total number of instances currently idle in this pool or a negative value if unsupported
      Throws:
        `java.lang.UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

    - #### getNumActive

          int getNumActive()
                           throws java.lang.UnsupportedOperationException

      Returns the total number of instances current borrowed from this pool but not yet returned (optional operation). Returns a negative value if this information is not available.
      Returns:
        the total number of instances currently borrowed from this pool or a negative value if unsupported
      Throws:
        `java.lang.UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

    - #### clear

          void clear()
                     throws java.lang.Exception,
                            java.lang.UnsupportedOperationException

      Clears the pool, removing all pooled instances (optional operation). Throws `UnsupportedOperationException` if the pool cannot be cleared.
      Throws:
        `java.lang.UnsupportedOperationException` - when this implementation doesn't support the operation
        `java.lang.Exception`

    - #### clear

          void clear(K key)
                     throws java.lang.Exception,
                            java.lang.UnsupportedOperationException

      Clears the specified pool, removing all pooled instances corresponding to the given `key` (optional operation). Throws `UnsupportedOperationException` if the pool cannot be cleared.
      Parameters:
        `key` - the key to clear
      Throws:
        `java.lang.UnsupportedOperationException` - when this implementation doesn't support the operation
        `java.lang.Exception`

    - #### close

          void close()
                     throws java.lang.Exception

      Close this pool, and free any resources associated with it.

      Calling `addObject` or `borrowObject` after invoking this method on a pool will cause them to throw an `IllegalStateException`.

      Throws:
        `java.lang.Exception`

    - #### setFactory

          @Deprecated
          void setFactory(KeyedPoolableObjectFactory<K,V> factory)
                          throws java.lang.IllegalStateException,
                                 java.lang.UnsupportedOperationException

      Deprecated. to be removed in pool 2.0
      Sets the `factory` the pool uses to create new instances (optional operation). Trying to change the `factory` after a pool has been used will frequently throw an `UnsupportedOperationException`. It is up to the pool implementation to determine when it is acceptable to call this method.
      Parameters:
        `factory` - the `KeyedPoolableObjectFactory` used to create new instances.
      Throws:
        `java.lang.IllegalStateException` - when the factory cannot be set at this time
        `java.lang.UnsupportedOperationException` - when this implementation doesn't support the operation

Copyright © 2000-2020 Apache Software Foundation. All Rights Reserved.